<template>
  <div class="table" id="overview-table">
    <div class="row" id="top-catalogues">
      <div v-if="this.rows === 100" class="col-sm">
        {{ $t("message.common.all") }} {{ $t("message.navigation.catalogues") }}
      </div>
      <div v-else-if="this.rows === 20" class="col-sm" >
        Top {{this.rows}} {{ $t("message.navigation.catalogues") }}
      </div>
      <div v-else class="col-sm">
        Top {{this.rows}} {{ $t("message.navigation.catalogues") }}
      </div>
      <div class="col-sm" >
        <div class="overview-filter">
          <button class="btn btn-light btn-sm" v-on:click="showMore(12)" :class="{ 'active': this.rows == 12 || null}">Top 12</button>
          <button class="btn btn-light btn-sm" v-on:click="showMore(20)" :class="{ 'active': this.rows == 20}">Top 20</button>
          <button class="btn btn-light btn-sm" v-on:click="showMore(100)" :class="{ 'active': this.rows == 100}">{{ $t("message.common.all") }} {{ $t("message.navigation.catalogues") }}</button>
        </div>
      </div>
    </div>
    <div v-if="!isMobile() && !isExplorer()">
      <table class="table table-hover">
        <thead>
          <tr>
            <th v-on:click="sortTable(sortSpatial)" class="overview-row-left" width="100px">
              <span class="d-inline-block" tabindex="0" data-toggle="tooltip" title="Disabled tooltip">
                <span class="hide">{{sortSpatial}}</span>
                <span :class="{ 'active': sortColumn === sortSpatial }">{{ $t("message.dashboard.overview.table_title.country") }}</span>
                &nbsp;
                <span :class="{ 'up': sortColumn === sortSpatial & ascending === true}"></span>
                <span :class="{ 'down': sortColumn === sortSpatial & ascending === false}"></span>
              </span>
            </th>
            <th v-on:click="sortTable(sortTitle)" class="overview-row-name" width="170px">
              <span class="hide">{{sortTitle}}</span>
              <span :class="{ 'active': sortColumn === sortTitle }">{{ $t("message.dashboard.overview.table_title.name") }}</span>
              &nbsp;
              <span :class="{ 'up': sortColumn === sortTitle & ascending === true }"></span>
              <span :class="{ 'down': sortColumn === sortTitle & ascending === false}"></span>
            </th>
            <th v-on:click="sortTable(sortAccessibilityUrl)" class="overview-row" width="100px">
              <span v-tooltip.top-center="$t('message.dashboard.overview.table_tooltip.accessibility_access_url')">
                <div class="table-title">
                  <span :class="{ 'active': sortColumn === sortAccessibilityUrl }">{{$t("message.dashboard.overview.table_title.accessibility_access_url") }}<span class="hide">{{sortAccessibilityUrl}}</span></span>
                </div>
                <div class="sort-arrow">
                  <span :class="{ 'up': sortColumn === sortAccessibilityUrl & ascending === true}"></span>
                  <span :class="{ 'down': sortColumn === sortAccessibilityUrl & ascending === false}"></span>
                </div>
              </span>
            </th>
            <th v-on:click="sortTable(sortDownloadUrl)" class="overview-row" width="100px">
              <span v-tooltip.top-center="$t('message.dashboard.overview.table_tooltip.accessibility_download_url')">
                <div class="table-title">
                  <span  :class="{ 'active': sortDownloadUrl === sortDownloadUrl }">{{ $t("message.dashboard.overview.table_title.accessibility_download_url") }}</span> <span class="hide">{{sortDownloadUrl}}</span>
                </div>
                <div class="sort-arrow">
                  <span :class="{ 'up': sortColumn === sortDownloadUrl & ascending === true}"></span>
                  <span :class="{ 'down': sortColumn === sortDownloadUrl & ascending === false}"></span>
                </div>
              </span>
            </th>
            <th v-on:click="sortTable(sortDcat)" class="overview-row" width="100px">
              <span v-tooltip.top-center="$t('message.dashboard.overview.table_tooltip.dcat_ap')">
                <div class="table-title">
                  <span :class="{ 'active': sortColumn === sortDcat }">{{ $t("message.dashboard.overview.table_title.dcat_ap") }}</span>
                  <span class="hide">{{sortDcat}}</span>
                </div>
                <div class="sort-arrow">
                  <span :class="{ 'up': sortColumn === sortDcat & ascending === true}"></span>
                  <span :class="{ 'down': sortColumn === sortDcat & ascending === false}"></span>
                </div>
              </span>
            </th>
            <th v-on:click="sortTable(sortMachineReadable)" class="overview-row" width="100px">
              <span v-tooltip.top-center="$t('message.dashboard.overview.table_tooltip.machine_readability')">
                <div class="table-title">
                  <span :class="{ 'active': sortColumn === sortMachineReadable }">{{ $t("message.dashboard.overview.table_title.machine_readability") }}</span>
                  <span class="hide">{{sortMachineReadable}}</span>
                </div>
                <div class="sort-arrow">
                  <span :class="{ 'up': sortColumn === sortMachineReadable & ascending === true}"></span>
                  <span :class="{ 'down': sortColumn === sortMachineReadable & ascending === false}"></span>
                </div>
              </span>
            </th>
            <th v-on:click="sortTable(sortScoring)" class="overview-row" width="100px">
              <span v-tooltip.top-center="$t('message.dashboard.overview.table_title.scoring')">
                <div class="table-title">
                  <span :class="{ 'active': sortColumn === sortScoring }">{{ $t("message.dashboard.overview.table_title.scoring") }}</span>
                  <span class="hide">{{sortScoring}}</span>
                </div>
                <div class="sort-arrow">
                  <span :class="{ 'up': sortColumn === sortScoring & ascending === true}"></span>
                  <span :class="{ 'down': sortColumn === sortScoring & ascending === false}"></span>
                </div>
              </span>
            </th>
          </tr>
        </thead>
        <tbody>
         <div v-if="this.loading === true" class="lds-ring">
            <div></div>
            <div></div>
            <div></div>
            <div></div>
          </div>
          <tr v-for="row in getAllCatalogues.slice(0, rows)" :key="row.info.id">
            <td class="spatial-row" width="100px">
              <div>
                <img v-if="row.sortSpatial" :src="getCountryFlagImg(row.sortSpatial)" width="30px" class="flag-icon">
                <img v-else :src="getCountryFlagImg('europe')" width="30px" class="flag-icon">
              </div>
            </td>
            <td width="180px">
              <!----------------- isExplorer() ----------------->
              <router-link class="name-row" v-if="isExplorer()" :to="{ name: 'CatalogueDetailDashboard', params: {id: row.info.id, title: row.info.title, spatial: row.info.spatial, rating: row.score}}">{{row.sortTitle}} <span v-if="row.sortTitle && row.sortTitle.includes('Europe')">(EU)</span><span v-else><span v-if="sortSpatial != null">({{row.sortSpatial}})</span></span></router-link>
              <router-link class="name-row" v-else :to="{ name: 'CatalogueDetailDashboard', params: {id: row.info.id, title: row.info.title, spatial: row.info.spatial, rating: row.score}, query: { locale: $i18n.locale }}">{{row.sortTitle}} <span v-if="row.sortTitle && row.sortTitle.includes('Europe')">(EU)</span><span v-else><span v-if="sortSpatial != null">({{row.sortSpatial}})</span></span> </router-link>
            </td>
            <td v-for="dimension in dimensions" :key="dimension" width="100px">
              <div v-if="row[`sort${dimension}`] == -1" class="overview-row">
                <!----------------- isMobile() ----------------->
                <p v-if="isMobile()" id="nodata">-</p>
                <img v-else src="../assets/img/na_4.png" height="35px">
              </div>
              <div v-else class="overview-row">
                <div v-if="dimension === 'Scoring'">
                  <div v-if="row[`sort${dimension}`] >= 351" class="scoring-excellent">{{$t('message.methodology.scoring.table.excellent')}} </div>
                  <div v-else-if="row[`sort${dimension}`] >= 221 && row[`sort${dimension}`] <= 350 " class="scoring-good">{{$t('message.methodology.scoring.table.good')}} </div>
                  <div v-else-if="row[`sort${dimension}`] >= 121 && row[`sort${dimension}`] <= 220 " class="scoring-enough">{{$t('message.methodology.scoring.table.just_enough')}} </div>
                  <div v-else-if="row[`sort${dimension}`] <= 120 && row[`sort${dimension}`] >0" class="scoring-bad">{{$t('message.methodology.scoring.table.bad')}}</div>
                  <div v-else><img src="../assets/img/na_4.png" height="35px"></div>

                </div>
                <div v-else-if="row[`sort${dimension}`] === undefined"> <img src="../assets/img/na_4.png" height="35px"> </div>
                <div v-else>
                <span class="access-overview">{{row[`sort${dimension}`]}} % </span>
                <div class="progress" style="height: 4px;">
                    <div class="progress-bar" role="progressbar" :style="`width:${row[`sort${dimension}`]}%`"> </div>
                 </div>
                </div>
              </div>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
</template>
<script>
/* eslint-disable */
import VueEvents from 'vue-events'
import Vue from 'vue'
// import Actions and Getters from Store Module
import { mapActions, mapGetters } from 'vuex'
import Sticky from 'vue-sticky-directive'
import VTooltip from 'v-tooltip'

Vue.use(VTooltip)
Vue.use(VueEvents)

export default {
  components: {},
  directives: {
    Sticky
  },
  data () {
    return {
      loading: true,
      ascending: true,
      sortColumn: '',
      spatial: 'spatial',
      rating: 'rating',
      id: 'id',
      rows: '12',
      title: 'title',
      dimensions: ['AccessibilityUrl', 'DownloadUrl', 'Dcat', 'MachineReadable', 'Scoring'],
      sortAccessibilityUrl: 'sortAccessibilityUrl',
      sortDownloadUrl: 'sortDownloadUrl',
      sortMachineReadable: 'sortMachineReadable',
      sortDcat: 'sortDcat',
      sortScoring: 'sortScoring',
      sortTitle: 'sortTitle',
      sortSpatial: 'sortSpatial'
    }
  },
  mounted () {
    this.sortTableStart(this.sortSpatial)
  },
  methods: {
    // import store-actions
    ...mapActions([
      'loadAllCatalogues'
    ]),
    sortTable: function (x) {
      if (this.sortColumn === x) {
        this.ascending = !this.ascending
      } else {
        this.ascending = false
        this.sortColumn = x
      }
      var ascending = this.ascending
      this.getAllCatalogues.sort(function (a, b) {
        if (a[x] > b[x]) {
          return ascending ? 1 : -1
        } else if (a[x] < b[x]) {
          return ascending ? -1 : 1
        }
        return 0
      })
    },
    sortTableStart: function (x) {
      if (this.sortColumn === x) {
        this.ascending = !this.ascending
      } else {
        this.ascending = false
        this.sortColumn = x
      }
      let ascending = this.ascending
      this.getAllCatalogues.sort(function (a, b) {
        if (a[x] > b[x]) {
          return ascending ? 1 : -1
        } else if (a[x] < b[x]) {
          return ascending ? -1 : 1
        }
        return 0
      })
    },
    activate: function (el) {
      this.active_el = el
    },
    init () {
      this.addSortableValues(this.getAllCatalogues)
      this.sortTableStart(this.sortSpatial)
    },
    addSortableValues (arr) {
      // Workaround Solution, all other cleaner ideas didn't work.
      for (var x = 0; x < arr.length; x++) {
        let catalogue = this.getAllCatalogues[x]
        if (catalogue.interoperability.formatMediaTypeMachineReadable === null) {
          Vue.set(this.getAllCatalogues[x], 'sortMachineReadable', -1)
        } else {
          Vue.set(this.getAllCatalogues[x], 'sortMachineReadable', catalogue.interoperability.formatMediaTypeMachineReadable.map(el => el.percentage)[0])
        }
        if (catalogue.accessibility.accessUrlStatusCodes === null || catalogue.accessibility.accessUrlStatusCodes.length === 0 ) {
          Vue.set(this.getAllCatalogues[x], 'sortAccessibilityUrl', -1)
        } else {
          Vue.set(this.getAllCatalogues[x], 'sortAccessibilityUrl', catalogue.accessibility.accessUrlStatusCodes.map(el => el.percentage)[0])
        }
        if (catalogue.accessibility.downloadUrlStatusCodes === null || catalogue.accessibility.downloadUrlStatusCodes.length === 0) {
          Vue.set(this.getAllCatalogues[x], 'sortDownloadUrl', -1)
        } else {
          Vue.set(this.getAllCatalogues[x], 'sortDownloadUrl', catalogue.accessibility.downloadUrlStatusCodes.map(el => el.percentage)[0])
        }
        if (catalogue.interoperability.dcatApCompliance === null) {
          Vue.set(this.getAllCatalogues[x], 'sortDcat', -1)
        } else {
          Vue.set(this.getAllCatalogues[x], 'sortDcat', catalogue.interoperability.dcatApCompliance.map(el => el.percentage)[0])
        }
        Vue.set(this.getAllCatalogues[x], 'sortScoring', catalogue.score)
        Vue.set(this.getAllCatalogues[x], 'sortTitle', catalogue.info.title)
        Vue.set(this.getAllCatalogues[x], 'sortSpatial', catalogue.info.spatial)
        // Set EU as default spatial value
        if (catalogue.spatial === null) Vue.set(this.getAllCatalogues[x], 'spatial', 'EU')
      }
    },
    isMobile () {
      return /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)
    },
    isExplorer () {
      return navigator.userAgent.indexOf('MSIE ') > -1 || navigator.userAgent.indexOf('Trident/') > -1 || window.navigator.userAgent.indexOf('Edge') > -1
    },
    showMore (x) {
      this.rows = x
      return this.rows
    },
    /**
     * @description         Returns an image of a flag.
     * @param { String }    countryId - The ID (example: 'en', 'de', 'fr') of a country to get the flag from.
     * @returns { String }  An image, represented by its absolute path.
     */
    getCountryFlagImg (countryId) {
      let img
      try {
        img = require(`@/assets/img/flags/${countryId.toLowerCase()}.png`)
      } catch (err) {
        img = require('@/assets/img/flags/europe.png')
      }
      return img
    }
  },
  computed: {
    // import store-getters
    ...mapGetters([
      'getAllCatalogues'
    ])
  },
  created () {
    this.loading = true
    this.loadAllCatalogues()
      .then(() => {
        this.loading = false
        this.init()
      })
      .catch(() => {})
      .finally(() => this.loading = false)
  }
}
</script>

<style>
.hide{
  visibility: hidden;
  font-size: 0px;
}

.scoring-excellent {
  text-align: center;
  background-color: #ebfff6;
  border-radius: 2px;
}

.scoring-good {
  text-align: center;
  background-color: #ebfeff;
  border-radius: 2px;
}
.scoring-enough {
  text-align: center;
  background-color: #ffffeb;
  border-radius: 2px;
}
.scoring-bad {
  text-align: center;
  background-color: #ffebeb;
  border-radius: 2px;
}

#top-catalogues {
  font-size: 16px;
  font-weight: 600;
}

.name-row {
  font-weight: 400 !important;
  font-size: 14px !important;
  color: #3B6AA0 !important;
}

.active-table-head{
  text-decoration:underline;
}
.is-red{
  background: red;
}
.active{
   text-decoration: none;
}
.down {
  border: solid black;
  border-width: 0 1px 1px 0;
  display: inline-block;
  padding: 2px;
  transform: rotate(45deg);
  -webkit-transform: rotate(45deg);
  margin-bottom:3px
}
.up {
  border: solid black;
  border-width: 0 1px 1px 0;
  display: inline-block;
  padding: 2px;
  transform: rotate(-135deg);
  -webkit-transform: rotate(-135deg);
  margin-bottom:1px
}
</style>
